/* game-headerbar.c generated by valac 0.56.17, the Vala compiler
 * generated from game-headerbar.vala, do not modify */

/*
   This file is part of GNOME 2048.

   Copyright (C) 2014-2015 Juan R. García Blanco <juanrgar@gmail.com>
   Copyright (C) 2016-2019 Arnaud Bonatti <arnaud.bonatti@gmail.com>

   GNOME 2048 is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   GNOME 2048 is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with GNOME 2048.  If not, see <https://www.gnu.org/licenses/>.
*/

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_GAME_HEADER_BAR (game_header_bar_get_type ())
#define GAME_HEADER_BAR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GAME_HEADER_BAR, GameHeaderBar))
#define GAME_HEADER_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GAME_HEADER_BAR, GameHeaderBarClass))
#define IS_GAME_HEADER_BAR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GAME_HEADER_BAR))
#define IS_GAME_HEADER_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GAME_HEADER_BAR))
#define GAME_HEADER_BAR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GAME_HEADER_BAR, GameHeaderBarClass))

typedef struct _GameHeaderBar GameHeaderBar;
typedef struct _GameHeaderBarClass GameHeaderBarClass;
typedef struct _GameHeaderBarPrivate GameHeaderBarPrivate;
enum  {
	GAME_HEADER_BAR_0_PROPERTY,
	GAME_HEADER_BAR_NUM_PROPERTIES
};
static GParamSpec* game_header_bar_properties[GAME_HEADER_BAR_NUM_PROPERTIES];

#define TYPE_GAME (game_get_type ())
#define GAME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GAME, Game))
#define GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GAME, GameClass))
#define IS_GAME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GAME))
#define IS_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GAME))
#define GAME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GAME, GameClass))

typedef struct _Game Game;
typedef struct _GameClass GameClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
enum  {
	GAME_HEADER_BAR_POPOVER_CLOSED_SIGNAL,
	GAME_HEADER_BAR_NUM_SIGNALS
};
static guint game_header_bar_signals[GAME_HEADER_BAR_NUM_SIGNALS] = {0};

struct _GameHeaderBar {
	GtkHeaderBar parent_instance;
	GameHeaderBarPrivate * priv;
};

struct _GameHeaderBarClass {
	GtkHeaderBarClass parent_class;
};

struct _GameHeaderBarPrivate {
	GtkLabel* _score;
	GtkMenuButton* _new_game_button;
	GtkMenuButton* _hamburger_button;
};

static gint GameHeaderBar_private_offset;
static gpointer game_header_bar_parent_class = NULL;

VALA_EXTERN GType game_header_bar_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHeaderBar, g_object_unref)
static void game_header_bar_test_popover_closed (GameHeaderBar* self);
VALA_EXTERN gboolean game_header_bar_has_popover (GameHeaderBar* self);
VALA_EXTERN void game_header_bar_clear_subtitle (GameHeaderBar* self);
VALA_EXTERN void game_header_bar_finished (GameHeaderBar* self);
VALA_EXTERN void game_header_bar_set_score (GameHeaderBar* self,
                                GObject* game,
                                GParamSpec* unused);
VALA_EXTERN GType game_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Game, g_object_unref)
VALA_EXTERN glong game_get_score (Game* self);
VALA_EXTERN void _game_header_bar_update_hamburger_menu (GameHeaderBar* self,
                                             gboolean allow_undo);
static inline void _game_header_bar_append_undo_section (GMenu** menu);
static inline void _game_header_bar_append_scores_section (GMenu** menu);
static inline void _game_header_bar_append_app_actions_section (GMenu** menu);
VALA_EXTERN void game_header_bar_toggle_hamburger_menu (GameHeaderBar* self);
VALA_EXTERN void _game_header_bar_update_new_game_menu (GameHeaderBar* self,
                                            guint8 rows,
                                            guint8 cols);
static void _game_header_bar_append_new_game_item (const gchar* label,
                                            guint8 rows,
                                            guint8 cols,
                                            GMenu** menu);
VALA_EXTERN gboolean grid_is_disallowed_grid_size (guint8* rows,
                                       guint8* cols);
VALA_EXTERN void game_header_bar_toggle_new_game (GameHeaderBar* self);
VALA_EXTERN GameHeaderBar* game_header_bar_new (void);
VALA_EXTERN GameHeaderBar* game_header_bar_construct (GType object_type);
static GObject * game_header_bar_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties);
static void _game_header_bar_test_popover_closed_g_object_notify (GObject* _sender,
                                                           GParamSpec* pspec,
                                                           gpointer self);
static void game_header_bar_finalize (GObject * obj);
static GType game_header_bar_get_type_once (void);

static inline gpointer
game_header_bar_get_instance_private (GameHeaderBar* self)
{
	return G_STRUCT_MEMBER_P (self, GameHeaderBar_private_offset);
}

static void
game_header_bar_test_popover_closed (GameHeaderBar* self)
{
#line 42 "../src/game-headerbar.vala"
	g_return_if_fail (self != NULL);
#line 44 "../src/game-headerbar.vala"
	if (!game_header_bar_has_popover (self)) {
#line 45 "../src/game-headerbar.vala"
		g_signal_emit (self, game_header_bar_signals[GAME_HEADER_BAR_POPOVER_CLOSED_SIGNAL], 0);
#line 157 "game-headerbar.c"
	}
}

gboolean
game_header_bar_has_popover (GameHeaderBar* self)
{
	gboolean _tmp0_ = FALSE;
	GtkMenuButton* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean result;
#line 48 "../src/game-headerbar.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 50 "../src/game-headerbar.vala"
	_tmp1_ = self->priv->_hamburger_button;
#line 50 "../src/game-headerbar.vala"
	_tmp2_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp1_);
#line 50 "../src/game-headerbar.vala"
	_tmp3_ = _tmp2_;
#line 50 "../src/game-headerbar.vala"
	if (_tmp3_) {
#line 50 "../src/game-headerbar.vala"
		_tmp0_ = TRUE;
#line 181 "game-headerbar.c"
	} else {
		GtkMenuButton* _tmp4_;
		gboolean _tmp5_;
		gboolean _tmp6_;
#line 50 "../src/game-headerbar.vala"
		_tmp4_ = self->priv->_new_game_button;
#line 50 "../src/game-headerbar.vala"
		_tmp5_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp4_);
#line 50 "../src/game-headerbar.vala"
		_tmp6_ = _tmp5_;
#line 50 "../src/game-headerbar.vala"
		_tmp0_ = _tmp6_;
#line 194 "game-headerbar.c"
	}
#line 50 "../src/game-headerbar.vala"
	result = _tmp0_;
#line 50 "../src/game-headerbar.vala"
	return result;
#line 200 "game-headerbar.c"
}

void
game_header_bar_clear_subtitle (GameHeaderBar* self)
{
#line 57 "../src/game-headerbar.vala"
	g_return_if_fail (self != NULL);
#line 59 "../src/game-headerbar.vala"
	gtk_header_bar_set_subtitle ((GtkHeaderBar*) self, NULL);
#line 60 "../src/game-headerbar.vala"
	gtk_header_bar_set_has_subtitle ((GtkHeaderBar*) self, FALSE);
#line 212 "game-headerbar.c"
}

void
game_header_bar_finished (GameHeaderBar* self)
{
#line 63 "../src/game-headerbar.vala"
	g_return_if_fail (self != NULL);
#line 65 "../src/game-headerbar.vala"
	gtk_header_bar_set_has_subtitle ((GtkHeaderBar*) self, TRUE);
#line 67 "../src/game-headerbar.vala"
	gtk_header_bar_set_subtitle ((GtkHeaderBar*) self, _ ("Game Over"));
#line 224 "game-headerbar.c"
}

void
game_header_bar_set_score (GameHeaderBar* self,
                           GObject* game,
                           GParamSpec* unused)
{
	GtkLabel* _tmp0_;
	glong _tmp1_;
	glong _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
#line 70 "../src/game-headerbar.vala"
	g_return_if_fail (self != NULL);
#line 70 "../src/game-headerbar.vala"
	g_return_if_fail (game != NULL);
#line 70 "../src/game-headerbar.vala"
	g_return_if_fail (unused != NULL);
#line 72 "../src/game-headerbar.vala"
	_tmp0_ = self->priv->_score;
#line 72 "../src/game-headerbar.vala"
	_tmp1_ = game_get_score (G_TYPE_CHECK_INSTANCE_CAST (game, TYPE_GAME, Game));
#line 72 "../src/game-headerbar.vala"
	_tmp2_ = _tmp1_;
#line 72 "../src/game-headerbar.vala"
	_tmp3_ = g_strdup_printf ("%li", _tmp2_);
#line 72 "../src/game-headerbar.vala"
	_tmp4_ = _tmp3_;
#line 72 "../src/game-headerbar.vala"
	gtk_label_set_label (_tmp0_, _tmp4_);
#line 72 "../src/game-headerbar.vala"
	_g_free0 (_tmp4_);
#line 257 "game-headerbar.c"
}

void
_game_header_bar_update_hamburger_menu (GameHeaderBar* self,
                                        gboolean allow_undo)
{
	GMenu* menu = NULL;
	GMenu* _tmp0_;
	GMenu* _tmp1_;
	GtkMenuButton* _tmp2_;
	GMenu* _tmp3_;
#line 79 "../src/game-headerbar.vala"
	g_return_if_fail (self != NULL);
#line 81 "../src/game-headerbar.vala"
	_tmp0_ = g_menu_new ();
#line 81 "../src/game-headerbar.vala"
	menu = _tmp0_;
#line 83 "../src/game-headerbar.vala"
	if (allow_undo) {
#line 84 "../src/game-headerbar.vala"
		_game_header_bar_append_undo_section (&menu);
#line 279 "game-headerbar.c"
	}
#line 85 "../src/game-headerbar.vala"
	_game_header_bar_append_scores_section (&menu);
#line 86 "../src/game-headerbar.vala"
	_game_header_bar_append_app_actions_section (&menu);
#line 88 "../src/game-headerbar.vala"
	_tmp1_ = menu;
#line 88 "../src/game-headerbar.vala"
	g_menu_freeze (_tmp1_);
#line 89 "../src/game-headerbar.vala"
	_tmp2_ = self->priv->_hamburger_button;
#line 89 "../src/game-headerbar.vala"
	_tmp3_ = menu;
#line 89 "../src/game-headerbar.vala"
	gtk_menu_button_set_menu_model (_tmp2_, G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, g_menu_model_get_type (), GMenuModel));
#line 79 "../src/game-headerbar.vala"
	_g_object_unref0 (menu);
#line 297 "game-headerbar.c"
}

static inline void
_game_header_bar_append_undo_section (GMenu** menu)
{
	GMenu* section = NULL;
	GMenu* _tmp0_;
#line 92 "../src/game-headerbar.vala"
	g_return_if_fail (*menu != NULL);
#line 94 "../src/game-headerbar.vala"
	_tmp0_ = g_menu_new ();
#line 94 "../src/game-headerbar.vala"
	section = _tmp0_;
#line 97 "../src/game-headerbar.vala"
	g_menu_append (section, _ ("Undo"), "ui.undo");
#line 99 "../src/game-headerbar.vala"
	g_menu_freeze (section);
#line 100 "../src/game-headerbar.vala"
	g_menu_append_section (*menu, NULL, (GMenuModel*) section);
#line 92 "../src/game-headerbar.vala"
	_g_object_unref0 (section);
#line 319 "game-headerbar.c"
}

static inline void
_game_header_bar_append_scores_section (GMenu** menu)
{
	GMenu* section = NULL;
	GMenu* _tmp0_;
#line 103 "../src/game-headerbar.vala"
	g_return_if_fail (*menu != NULL);
#line 105 "../src/game-headerbar.vala"
	_tmp0_ = g_menu_new ();
#line 105 "../src/game-headerbar.vala"
	section = _tmp0_;
#line 108 "../src/game-headerbar.vala"
	g_menu_append (section, _ ("Scores"), "ui.scores");
#line 110 "../src/game-headerbar.vala"
	g_menu_freeze (section);
#line 111 "../src/game-headerbar.vala"
	g_menu_append_section (*menu, NULL, (GMenuModel*) section);
#line 103 "../src/game-headerbar.vala"
	_g_object_unref0 (section);
#line 341 "game-headerbar.c"
}

static inline void
_game_header_bar_append_app_actions_section (GMenu** menu)
{
	GMenu* section = NULL;
	GMenu* _tmp0_;
#line 114 "../src/game-headerbar.vala"
	g_return_if_fail (*menu != NULL);
#line 116 "../src/game-headerbar.vala"
	_tmp0_ = g_menu_new ();
#line 116 "../src/game-headerbar.vala"
	section = _tmp0_;
#line 119 "../src/game-headerbar.vala"
	g_menu_append (section, _ ("Keyboard Shortcuts"), "win.show-help-overlay");
#line 122 "../src/game-headerbar.vala"
	g_menu_append (section, _ ("About 2048"), "ui.about");
#line 124 "../src/game-headerbar.vala"
	g_menu_freeze (section);
#line 125 "../src/game-headerbar.vala"
	g_menu_append_section (*menu, NULL, (GMenuModel*) section);
#line 114 "../src/game-headerbar.vala"
	_g_object_unref0 (section);
#line 365 "game-headerbar.c"
}

void
game_header_bar_toggle_hamburger_menu (GameHeaderBar* self)
{
	GtkMenuButton* _tmp0_;
	GtkMenuButton* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 128 "../src/game-headerbar.vala"
	g_return_if_fail (self != NULL);
#line 130 "../src/game-headerbar.vala"
	_tmp0_ = self->priv->_hamburger_button;
#line 130 "../src/game-headerbar.vala"
	_tmp1_ = self->priv->_hamburger_button;
#line 130 "../src/game-headerbar.vala"
	_tmp2_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp1_);
#line 130 "../src/game-headerbar.vala"
	_tmp3_ = _tmp2_;
#line 130 "../src/game-headerbar.vala"
	gtk_toggle_button_set_active ((GtkToggleButton*) _tmp0_, !_tmp3_);
#line 387 "game-headerbar.c"
}

void
_game_header_bar_update_new_game_menu (GameHeaderBar* self,
                                       guint8 rows,
                                       guint8 cols)
{
	GMenu* menu = NULL;
	GMenu* _tmp0_;
	gboolean is_square = FALSE;
	gboolean disallowed_grid = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	GMenu* _tmp8_;
	GtkMenuButton* _tmp9_;
	GMenu* _tmp10_;
#line 137 "../src/game-headerbar.vala"
	g_return_if_fail (self != NULL);
#line 139 "../src/game-headerbar.vala"
	_tmp0_ = g_menu_new ();
#line 139 "../src/game-headerbar.vala"
	menu = _tmp0_;
#line 142 "../src/game-headerbar.vala"
	_game_header_bar_append_new_game_item (_ ("3 × 3"), (guint8) 3, (guint8) 3, &menu);
#line 148 "../src/game-headerbar.vala"
	_game_header_bar_append_new_game_item (_ ("4 × 4"), (guint8) 4, (guint8) 4, &menu);
#line 154 "../src/game-headerbar.vala"
	_game_header_bar_append_new_game_item (_ ("5 × 5"), (guint8) 5, (guint8) 5, &menu);
#line 159 "../src/game-headerbar.vala"
	is_square = rows == cols;
#line 160 "../src/game-headerbar.vala"
	_tmp1_ = grid_is_disallowed_grid_size (&rows, &cols);
#line 160 "../src/game-headerbar.vala"
	disallowed_grid = _tmp1_;
#line 161 "../src/game-headerbar.vala"
	if (disallowed_grid) {
#line 161 "../src/game-headerbar.vala"
		_tmp2_ = !is_square;
#line 427 "game-headerbar.c"
	} else {
#line 161 "../src/game-headerbar.vala"
		_tmp2_ = FALSE;
#line 431 "game-headerbar.c"
	}
#line 161 "../src/game-headerbar.vala"
	if (_tmp2_) {
#line 163 "../src/game-headerbar.vala"
		g_warning ("game-headerbar.vala:163: %s", _ ("Grids of size 1 by 2 are disallowed."));
#line 437 "game-headerbar.c"
	}
#line 165 "../src/game-headerbar.vala"
	if (!disallowed_grid) {
#line 441 "game-headerbar.c"
		gboolean _tmp4_ = FALSE;
#line 165 "../src/game-headerbar.vala"
		if (!is_square) {
#line 165 "../src/game-headerbar.vala"
			_tmp4_ = TRUE;
#line 447 "game-headerbar.c"
		} else {
			gboolean _tmp5_ = FALSE;
			gboolean _tmp6_ = FALSE;
			gboolean _tmp7_ = FALSE;
#line 165 "../src/game-headerbar.vala"
			if (is_square) {
#line 165 "../src/game-headerbar.vala"
				_tmp7_ = ((gint) rows) != 4;
#line 456 "game-headerbar.c"
			} else {
#line 165 "../src/game-headerbar.vala"
				_tmp7_ = FALSE;
#line 460 "game-headerbar.c"
			}
#line 165 "../src/game-headerbar.vala"
			if (_tmp7_) {
#line 165 "../src/game-headerbar.vala"
				_tmp6_ = ((gint) rows) != 3;
#line 466 "game-headerbar.c"
			} else {
#line 165 "../src/game-headerbar.vala"
				_tmp6_ = FALSE;
#line 470 "game-headerbar.c"
			}
#line 165 "../src/game-headerbar.vala"
			if (_tmp6_) {
#line 165 "../src/game-headerbar.vala"
				_tmp5_ = ((gint) rows) != 5;
#line 476 "game-headerbar.c"
			} else {
#line 165 "../src/game-headerbar.vala"
				_tmp5_ = FALSE;
#line 480 "game-headerbar.c"
			}
#line 165 "../src/game-headerbar.vala"
			_tmp4_ = _tmp5_;
#line 484 "game-headerbar.c"
		}
#line 165 "../src/game-headerbar.vala"
		_tmp3_ = _tmp4_;
#line 488 "game-headerbar.c"
	} else {
#line 165 "../src/game-headerbar.vala"
		_tmp3_ = FALSE;
#line 492 "game-headerbar.c"
	}
#line 165 "../src/game-headerbar.vala"
	if (_tmp3_) {
#line 167 "../src/game-headerbar.vala"
		_game_header_bar_append_new_game_item (_ ("Custom"), rows, cols, &menu);
#line 498 "game-headerbar.c"
	}
#line 169 "../src/game-headerbar.vala"
	_tmp8_ = menu;
#line 169 "../src/game-headerbar.vala"
	g_menu_freeze (_tmp8_);
#line 170 "../src/game-headerbar.vala"
	_tmp9_ = self->priv->_new_game_button;
#line 170 "../src/game-headerbar.vala"
	_tmp10_ = menu;
#line 170 "../src/game-headerbar.vala"
	gtk_menu_button_set_menu_model (_tmp9_, G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, g_menu_model_get_type (), GMenuModel));
#line 137 "../src/game-headerbar.vala"
	_g_object_unref0 (menu);
#line 512 "game-headerbar.c"
}

static void
_game_header_bar_append_new_game_item (const gchar* label,
                                       guint8 rows,
                                       guint8 cols,
                                       GMenu** menu)
{
	GVariant* variant = NULL;
	GVariant* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
#line 172 "../src/game-headerbar.vala"
	g_return_if_fail (label != NULL);
#line 172 "../src/game-headerbar.vala"
	g_return_if_fail (*menu != NULL);
#line 174 "../src/game-headerbar.vala"
	_tmp0_ = g_variant_new ("(yy)", rows, cols, NULL);
#line 174 "../src/game-headerbar.vala"
	g_variant_ref_sink (_tmp0_);
#line 174 "../src/game-headerbar.vala"
	variant = _tmp0_;
#line 175 "../src/game-headerbar.vala"
	_tmp1_ = g_variant_print (variant, TRUE);
#line 175 "../src/game-headerbar.vala"
	_tmp2_ = _tmp1_;
#line 175 "../src/game-headerbar.vala"
	_tmp3_ = g_strconcat ("ui.new-game-sized(", _tmp2_, NULL);
#line 175 "../src/game-headerbar.vala"
	_tmp4_ = _tmp3_;
#line 175 "../src/game-headerbar.vala"
	_tmp5_ = g_strconcat (_tmp4_, ")", NULL);
#line 175 "../src/game-headerbar.vala"
	_tmp6_ = _tmp5_;
#line 175 "../src/game-headerbar.vala"
	g_menu_append (*menu, label, _tmp6_);
#line 175 "../src/game-headerbar.vala"
	_g_free0 (_tmp6_);
#line 175 "../src/game-headerbar.vala"
	_g_free0 (_tmp4_);
#line 175 "../src/game-headerbar.vala"
	_g_free0 (_tmp2_);
#line 172 "../src/game-headerbar.vala"
	_g_variant_unref0 (variant);
#line 561 "game-headerbar.c"
}

void
game_header_bar_toggle_new_game (GameHeaderBar* self)
{
	GtkMenuButton* _tmp0_;
	GtkMenuButton* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 178 "../src/game-headerbar.vala"
	g_return_if_fail (self != NULL);
#line 180 "../src/game-headerbar.vala"
	_tmp0_ = self->priv->_new_game_button;
#line 180 "../src/game-headerbar.vala"
	_tmp1_ = self->priv->_new_game_button;
#line 180 "../src/game-headerbar.vala"
	_tmp2_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp1_);
#line 180 "../src/game-headerbar.vala"
	_tmp3_ = _tmp2_;
#line 180 "../src/game-headerbar.vala"
	gtk_toggle_button_set_active ((GtkToggleButton*) _tmp0_, !_tmp3_);
#line 583 "game-headerbar.c"
}

GameHeaderBar*
game_header_bar_construct (GType object_type)
{
	GameHeaderBar * self = NULL;
#line 24 "../src/game-headerbar.vala"
	self = (GameHeaderBar*) g_object_new (object_type, NULL);
#line 24 "../src/game-headerbar.vala"
	return self;
#line 594 "game-headerbar.c"
}

GameHeaderBar*
game_header_bar_new (void)
{
#line 24 "../src/game-headerbar.vala"
	return game_header_bar_construct (TYPE_GAME_HEADER_BAR);
#line 602 "game-headerbar.c"
}

static void
_game_header_bar_test_popover_closed_g_object_notify (GObject* _sender,
                                                      GParamSpec* pspec,
                                                      gpointer self)
{
#line 38 "../src/game-headerbar.vala"
	game_header_bar_test_popover_closed ((GameHeaderBar*) self);
#line 612 "game-headerbar.c"
}

static GObject *
game_header_bar_constructor (GType type,
                             guint n_construct_properties,
                             GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GameHeaderBar * self;
	GtkMenuButton* _tmp0_;
	GtkMenuButton* _tmp1_;
#line 36 "../src/game-headerbar.vala"
	parent_class = G_OBJECT_CLASS (game_header_bar_parent_class);
#line 36 "../src/game-headerbar.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 36 "../src/game-headerbar.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_GAME_HEADER_BAR, GameHeaderBar);
#line 38 "../src/game-headerbar.vala"
	_tmp0_ = self->priv->_hamburger_button;
#line 38 "../src/game-headerbar.vala"
	g_signal_connect_object ((GObject*) _tmp0_, "notify::active", (GCallback) _game_header_bar_test_popover_closed_g_object_notify, self, 0);
#line 39 "../src/game-headerbar.vala"
	_tmp1_ = self->priv->_new_game_button;
#line 39 "../src/game-headerbar.vala"
	g_signal_connect_object ((GObject*) _tmp1_, "notify::active", (GCallback) _game_header_bar_test_popover_closed_g_object_notify, self, 0);
#line 36 "../src/game-headerbar.vala"
	return obj;
#line 641 "game-headerbar.c"
}

static void
game_header_bar_class_init (GameHeaderBarClass * klass,
                            gpointer klass_data)
{
#line 24 "../src/game-headerbar.vala"
	game_header_bar_parent_class = g_type_class_peek_parent (klass);
#line 24 "../src/game-headerbar.vala"
	g_type_class_adjust_private_offset (klass, &GameHeaderBar_private_offset);
#line 24 "../src/game-headerbar.vala"
	G_OBJECT_CLASS (klass)->constructor = game_header_bar_constructor;
#line 24 "../src/game-headerbar.vala"
	G_OBJECT_CLASS (klass)->finalize = game_header_bar_finalize;
#line 24 "../src/game-headerbar.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/TwentyFortyEight/ui/game-headerbar.ui");
#line 24 "../src/game-headerbar.vala"
	game_header_bar_signals[GAME_HEADER_BAR_POPOVER_CLOSED_SIGNAL] = g_signal_new ("popover-closed", TYPE_GAME_HEADER_BAR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 24 "../src/game-headerbar.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "_score", FALSE, GameHeaderBar_private_offset + G_STRUCT_OFFSET (GameHeaderBarPrivate, _score));
#line 24 "../src/game-headerbar.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "_new_game_button", FALSE, GameHeaderBar_private_offset + G_STRUCT_OFFSET (GameHeaderBarPrivate, _new_game_button));
#line 24 "../src/game-headerbar.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "_hamburger_button", FALSE, GameHeaderBar_private_offset + G_STRUCT_OFFSET (GameHeaderBarPrivate, _hamburger_button));
#line 666 "game-headerbar.c"
}

static void
game_header_bar_instance_init (GameHeaderBar * self,
                               gpointer klass)
{
#line 24 "../src/game-headerbar.vala"
	self->priv = game_header_bar_get_instance_private (self);
#line 24 "../src/game-headerbar.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 677 "game-headerbar.c"
}

static void
game_header_bar_finalize (GObject * obj)
{
	GameHeaderBar * self;
#line 24 "../src/game-headerbar.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_GAME_HEADER_BAR, GameHeaderBar);
#line 24 "../src/game-headerbar.vala"
	G_OBJECT_CLASS (game_header_bar_parent_class)->finalize (obj);
#line 688 "game-headerbar.c"
}

static GType
game_header_bar_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GameHeaderBarClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) game_header_bar_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GameHeaderBar), 0, (GInstanceInitFunc) game_header_bar_instance_init, NULL };
	GType game_header_bar_type_id;
	game_header_bar_type_id = g_type_register_static (gtk_header_bar_get_type (), "GameHeaderBar", &g_define_type_info, 0);
	GameHeaderBar_private_offset = g_type_add_instance_private (game_header_bar_type_id, sizeof (GameHeaderBarPrivate));
	return game_header_bar_type_id;
}

GType
game_header_bar_get_type (void)
{
	static volatile gsize game_header_bar_type_id__once = 0;
	if (g_once_init_enter (&game_header_bar_type_id__once)) {
		GType game_header_bar_type_id;
		game_header_bar_type_id = game_header_bar_get_type_once ();
		g_once_init_leave (&game_header_bar_type_id__once, game_header_bar_type_id);
	}
	return game_header_bar_type_id__once;
}

