/* view.c generated by valac 0.56.17, the Vala compiler
 * generated from view.vala, do not modify */

/*
   This file is part of GNOME 2048.

   Copyright (C) 2014-2015 Juan R. García Blanco <juanrgar@gmail.com>
   Copyright (C) 2016-2019 Arnaud Bonatti <arnaud.bonatti@gmail.com>

   GNOME 2048 is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   GNOME 2048 is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with GNOME 2048.  If not, see <https://www.gnu.org/licenses/>.
*/

#include <glib-object.h>
#include <cairo-gobject.h>
#include <glib.h>
#include <clutter/clutter.h>
#include <float.h>
#include <math.h>
#include <pango/pango.h>
#include <pango/pangocairo.h>
#include <stdlib.h>
#include <string.h>

#define ROUNDED_RECTANGLE_HALF_PI (G_PI / 2.0)
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_ROUNDED_RECTANGLE (rounded_rectangle_get_type ())
#define ROUNDED_RECTANGLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ROUNDED_RECTANGLE, RoundedRectangle))
#define ROUNDED_RECTANGLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ROUNDED_RECTANGLE, RoundedRectangleClass))
#define IS_ROUNDED_RECTANGLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ROUNDED_RECTANGLE))
#define IS_ROUNDED_RECTANGLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ROUNDED_RECTANGLE))
#define ROUNDED_RECTANGLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ROUNDED_RECTANGLE, RoundedRectangleClass))

typedef struct _RoundedRectangle RoundedRectangle;
typedef struct _RoundedRectangleClass RoundedRectangleClass;
typedef struct _RoundedRectanglePrivate RoundedRectanglePrivate;
enum  {
	ROUNDED_RECTANGLE_0_PROPERTY,
	ROUNDED_RECTANGLE_ACTOR_PROPERTY,
	ROUNDED_RECTANGLE_CANVAS_PROPERTY,
	ROUNDED_RECTANGLE_X_PROPERTY,
	ROUNDED_RECTANGLE_Y_PROPERTY,
	ROUNDED_RECTANGLE_WIDTH_PROPERTY,
	ROUNDED_RECTANGLE_HEIGHT_PROPERTY,
	ROUNDED_RECTANGLE_COLOR_PROPERTY,
	ROUNDED_RECTANGLE_NUM_PROPERTIES
};
static GParamSpec* rounded_rectangle_properties[ROUNDED_RECTANGLE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define __vala_ClutterColor_free0(var) ((var == NULL) ? NULL : (var = (_vala_ClutterColor_free (var), NULL)))

#define TYPE_TILE_VIEW (tile_view_get_type ())
#define TILE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TILE_VIEW, TileView))
#define TILE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TILE_VIEW, TileViewClass))
#define IS_TILE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TILE_VIEW))
#define IS_TILE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TILE_VIEW))
#define TILE_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TILE_VIEW, TileViewClass))

typedef struct _TileView TileView;
typedef struct _TileViewClass TileViewClass;
typedef struct _TileViewPrivate TileViewPrivate;
enum  {
	TILE_VIEW_0_PROPERTY,
	TILE_VIEW_NUM_PROPERTIES
};
static GParamSpec* tile_view_properties[TILE_VIEW_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define __vala_PangoFontDescription_free0(var) ((var == NULL) ? NULL : (var = (_vala_PangoFontDescription_free (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _RoundedRectangle {
	GObject parent_instance;
	RoundedRectanglePrivate * priv;
};

struct _RoundedRectangleClass {
	GObjectClass parent_class;
	gboolean (*_draw) (RoundedRectangle* self, cairo_t* ctx, gint width, gint height);
};

struct _RoundedRectanglePrivate {
	ClutterActor* _actor;
	ClutterCanvas* _canvas;
	ClutterColor _color;
	guint8 _color_index;
};

struct _TileView {
	RoundedRectangle parent_instance;
	TileViewPrivate * priv;
};

struct _TileViewClass {
	RoundedRectangleClass parent_class;
};

static gint RoundedRectangle_private_offset;
static gpointer rounded_rectangle_parent_class = NULL;
static GHashTable* rounded_rectangle_colors;
static GHashTable* rounded_rectangle_colors = NULL;
static gpointer tile_view_parent_class = NULL;

VALA_EXTERN GType rounded_rectangle_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (RoundedRectangle, g_object_unref)
VALA_EXTERN gboolean _rounded_rectangle_draw (RoundedRectangle* self,
                                  cairo_t* ctx,
                                  gint width,
                                  gint height);
static void _vala_ClutterColor_free (ClutterColor* self);
static void __vala_ClutterColor_free0_ (gpointer var);
VALA_EXTERN RoundedRectangle* rounded_rectangle_new (gfloat x,
                                         gfloat y,
                                         gfloat width,
                                         gfloat height);
VALA_EXTERN RoundedRectangle* rounded_rectangle_construct (GType object_type,
                                               gfloat x,
                                               gfloat y,
                                               gfloat width,
                                               gfloat height);
VALA_EXTERN void rounded_rectangle_resize (RoundedRectangle* self,
                               gfloat x,
                               gfloat y,
                               gfloat width,
                               gfloat height);
VALA_EXTERN ClutterActor* rounded_rectangle_get_actor (RoundedRectangle* self);
VALA_EXTERN void rounded_rectangle_idle_resize (RoundedRectangle* self);
VALA_EXTERN ClutterCanvas* rounded_rectangle_get_canvas (RoundedRectangle* self);
static gboolean rounded_rectangle_real__draw (RoundedRectangle* self,
                                       cairo_t* ctx,
                                       gint width,
                                       gint height);
static void _rounded_rectangle_new_color (guint8 tile_value,
                                   ClutterColor* color);
static ClutterColor* _vala_ClutterColor_copy (ClutterColor* self);
static void rounded_rectangle_set_x (RoundedRectangle* self,
                              gfloat value);
static void rounded_rectangle_set_y (RoundedRectangle* self,
                              gfloat value);
static void rounded_rectangle_set_width (RoundedRectangle* self,
                                  gfloat value);
static void rounded_rectangle_set_height (RoundedRectangle* self,
                                   gfloat value);
VALA_EXTERN guint8 rounded_rectangle_get_color (RoundedRectangle* self);
static void rounded_rectangle_set_color (RoundedRectangle* self,
                                  guint8 value);
static GObject * rounded_rectangle_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties);
static gboolean __rounded_rectangle_draw_clutter_canvas_draw (ClutterCanvas* _sender,
                                                       cairo_t* cr,
                                                       gint width,
                                                       gint height,
                                                       gpointer self);
static void rounded_rectangle_finalize (GObject * obj);
static GType rounded_rectangle_get_type_once (void);
static void _vala_rounded_rectangle_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec);
static void _vala_rounded_rectangle_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec);
VALA_EXTERN GType tile_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TileView, g_object_unref)
VALA_EXTERN TileView* tile_view_new (gfloat x,
                         gfloat y,
                         gfloat width,
                         gfloat height,
                         guint8 val);
VALA_EXTERN TileView* tile_view_construct (GType object_type,
                               gfloat x,
                               gfloat y,
                               gfloat width,
                               gfloat height,
                               guint8 val);
static gboolean tile_view_real__draw (RoundedRectangle* base,
                               cairo_t* ctx,
                               gint width,
                               gint height);
static void _vala_PangoFontDescription_free (PangoFontDescription* self);
static GType tile_view_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
rounded_rectangle_get_instance_private (RoundedRectangle* self)
{
	return G_STRUCT_MEMBER_P (self, RoundedRectangle_private_offset);
}

static void
_vala_ClutterColor_free (ClutterColor* self)
{
#line 86 "../src/view.vala"
	g_boxed_free (CLUTTER_TYPE_COLOR, self);
#line 228 "view.c"
}

static void
__vala_ClutterColor_free0_ (gpointer var)
{
#line 86 "../src/view.vala"
	(var == NULL) ? NULL : (var = (_vala_ClutterColor_free (var), NULL));
#line 236 "view.c"
}

RoundedRectangle*
rounded_rectangle_construct (GType object_type,
                             gfloat x,
                             gfloat y,
                             gfloat width,
                             gfloat height)
{
	RoundedRectangle * self = NULL;
#line 42 "../src/view.vala"
	self = (RoundedRectangle*) g_object_new (object_type, "x", x, "y", y, "width", width, "height", height, "color", 0, NULL);
#line 40 "../src/view.vala"
	return self;
#line 251 "view.c"
}

RoundedRectangle*
rounded_rectangle_new (gfloat x,
                       gfloat y,
                       gfloat width,
                       gfloat height)
{
#line 40 "../src/view.vala"
	return rounded_rectangle_construct (TYPE_ROUNDED_RECTANGLE, x, y, width, height);
#line 262 "view.c"
}

void
rounded_rectangle_resize (RoundedRectangle* self,
                          gfloat x,
                          gfloat y,
                          gfloat width,
                          gfloat height)
{
	ClutterActor* _tmp0_;
	ClutterActor* _tmp1_;
	ClutterActor* _tmp2_;
	ClutterActor* _tmp3_;
#line 45 "../src/view.vala"
	g_return_if_fail (self != NULL);
#line 47 "../src/view.vala"
	_tmp0_ = self->priv->_actor;
#line 47 "../src/view.vala"
	clutter_actor_set_x (_tmp0_, x);
#line 48 "../src/view.vala"
	_tmp1_ = self->priv->_actor;
#line 48 "../src/view.vala"
	clutter_actor_set_y (_tmp1_, y);
#line 49 "../src/view.vala"
	_tmp2_ = self->priv->_actor;
#line 49 "../src/view.vala"
	clutter_actor_set_width (_tmp2_, width);
#line 50 "../src/view.vala"
	_tmp3_ = self->priv->_actor;
#line 50 "../src/view.vala"
	clutter_actor_set_height (_tmp3_, height);
#line 294 "view.c"
}

void
rounded_rectangle_idle_resize (RoundedRectangle* self)
{
	ClutterCanvas* _tmp0_;
	ClutterActor* _tmp1_;
	gfloat _tmp2_;
	gfloat _tmp3_;
	ClutterActor* _tmp4_;
	gfloat _tmp5_;
	gfloat _tmp6_;
#line 53 "../src/view.vala"
	g_return_if_fail (self != NULL);
#line 55 "../src/view.vala"
	_tmp0_ = self->priv->_canvas;
#line 55 "../src/view.vala"
	_tmp1_ = self->priv->_actor;
#line 55 "../src/view.vala"
	_tmp2_ = clutter_actor_get_width (_tmp1_);
#line 55 "../src/view.vala"
	_tmp3_ = _tmp2_;
#line 55 "../src/view.vala"
	_tmp4_ = self->priv->_actor;
#line 55 "../src/view.vala"
	_tmp5_ = clutter_actor_get_height (_tmp4_);
#line 55 "../src/view.vala"
	_tmp6_ = _tmp5_;
#line 55 "../src/view.vala"
	if (!clutter_canvas_set_size (_tmp0_, (gint) ceilf (_tmp3_), (gint) ceilf (_tmp6_))) {
#line 325 "view.c"
		ClutterCanvas* _tmp7_;
#line 56 "../src/view.vala"
		_tmp7_ = self->priv->_canvas;
#line 56 "../src/view.vala"
		clutter_content_invalidate ((ClutterContent*) _tmp7_);
#line 331 "view.c"
	}
}

static gboolean
rounded_rectangle_real__draw (RoundedRectangle* self,
                              cairo_t* ctx,
                              gint width,
                              gint height)
{
	gdouble _tmp0_ = 0.0;
	gdouble radius = 0.0;
	ClutterColor _tmp1_;
	gboolean result;
#line 60 "../src/view.vala"
	g_return_val_if_fail (ctx != NULL, FALSE);
#line 62 "../src/view.vala"
	if (height > width) {
#line 62 "../src/view.vala"
		_tmp0_ = height / 20.0;
#line 351 "view.c"
	} else {
#line 62 "../src/view.vala"
		_tmp0_ = width / 20.0;
#line 355 "view.c"
	}
#line 62 "../src/view.vala"
	radius = _tmp0_;
#line 64 "../src/view.vala"
	cairo_save (ctx);
#line 65 "../src/view.vala"
	cairo_set_operator (ctx, CAIRO_OPERATOR_CLEAR);
#line 66 "../src/view.vala"
	cairo_paint (ctx);
#line 67 "../src/view.vala"
	cairo_restore (ctx);
#line 69 "../src/view.vala"
	cairo_new_sub_path (ctx);
#line 70 "../src/view.vala"
	cairo_arc (ctx, radius, radius, radius, G_PI, -ROUNDED_RECTANGLE_HALF_PI);
#line 71 "../src/view.vala"
	cairo_arc (ctx, width - radius, radius, radius, -ROUNDED_RECTANGLE_HALF_PI, (gdouble) 0);
#line 72 "../src/view.vala"
	cairo_arc (ctx, width - radius, height - radius, radius, (gdouble) 0, ROUNDED_RECTANGLE_HALF_PI);
#line 73 "../src/view.vala"
	cairo_arc (ctx, radius, height - radius, radius, ROUNDED_RECTANGLE_HALF_PI, G_PI);
#line 74 "../src/view.vala"
	cairo_close_path (ctx);
#line 76 "../src/view.vala"
	_tmp1_ = self->priv->_color;
#line 76 "../src/view.vala"
	clutter_cairo_set_source_color (ctx, &_tmp1_);
#line 77 "../src/view.vala"
	cairo_fill (ctx);
#line 79 "../src/view.vala"
	result = FALSE;
#line 79 "../src/view.vala"
	return result;
#line 389 "view.c"
}

gboolean
_rounded_rectangle_draw (RoundedRectangle* self,
                         cairo_t* ctx,
                         gint width,
                         gint height)
{
	RoundedRectangleClass* _klass_;
#line 60 "../src/view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 60 "../src/view.vala"
	_klass_ = ROUNDED_RECTANGLE_GET_CLASS (self);
#line 60 "../src/view.vala"
	if (_klass_->_draw) {
#line 60 "../src/view.vala"
		return _klass_->_draw (self, ctx, width, height);
#line 407 "view.c"
	}
#line 60 "../src/view.vala"
	return FALSE;
#line 411 "view.c"
}

static ClutterColor*
_vala_ClutterColor_copy (ClutterColor* self)
{
#line 122 "../src/view.vala"
	return g_boxed_copy (CLUTTER_TYPE_COLOR, self);
#line 419 "view.c"
}

static gpointer
__vala_ClutterColor_copy0 (gpointer self)
{
#line 122 "../src/view.vala"
	return self ? _vala_ClutterColor_copy (self) : NULL;
#line 427 "view.c"
}

static void
_rounded_rectangle_new_color (guint8 tile_value,
                              ClutterColor* color)
{
	ClutterColor _vala_color = {0};
	ClutterColor* nullable_color = NULL;
	GHashTable* _tmp0_;
	gconstpointer _tmp1_;
	ClutterColor* _tmp2_;
	guint8 sbits = 0U;
	GHashTable* _tmp3_;
	ClutterColor _tmp4_;
	ClutterColor* _tmp5_;
#line 118 "../src/view.vala"
	_vala_return_if_fail (((gint) tile_value) >= 12, "tile_value >= 12");
#line 118 "../src/view.vala"
	_vala_return_if_fail (((gint) tile_value) <= 81, "tile_value <= 81");
#line 122 "../src/view.vala"
	_tmp0_ = rounded_rectangle_colors;
#line 122 "../src/view.vala"
	_tmp1_ = g_hash_table_lookup (_tmp0_, (gpointer) ((gintptr) (((tile_value - 1) % 11) + 1)));
#line 122 "../src/view.vala"
	_tmp2_ = __vala_ClutterColor_copy0 ((ClutterColor*) _tmp1_);
#line 122 "../src/view.vala"
	nullable_color = _tmp2_;
#line 123 "../src/view.vala"
	if (nullable_color == NULL) {
#line 124 "../src/view.vala"
		g_assert_not_reached ();
#line 459 "view.c"
	}
#line 125 "../src/view.vala"
	_vala_color = (ClutterColor) (*nullable_color);
#line 127 "../src/view.vala"
	sbits = (guint8) fmod (pow ((gdouble) 2, (gdouble) tile_value), 7);
#line 128 "../src/view.vala"
	_vala_color.red = _vala_color.red << sbits;
#line 129 "../src/view.vala"
	_vala_color.green = _vala_color.green << sbits;
#line 130 "../src/view.vala"
	_vala_color.blue = _vala_color.blue << sbits;
#line 132 "../src/view.vala"
	_tmp3_ = rounded_rectangle_colors;
#line 132 "../src/view.vala"
	_tmp4_ = _vala_color;
#line 132 "../src/view.vala"
	_tmp5_ = __vala_ClutterColor_copy0 (&_tmp4_);
#line 132 "../src/view.vala"
	g_hash_table_insert (_tmp3_, (gpointer) ((gintptr) tile_value), _tmp5_);
#line 118 "../src/view.vala"
	__vala_ClutterColor_free0 (nullable_color);
#line 118 "../src/view.vala"
	if (color) {
#line 118 "../src/view.vala"
		*color = _vala_color;
#line 485 "view.c"
	}
}

ClutterActor*
rounded_rectangle_get_actor (RoundedRectangle* self)
{
	ClutterActor* result;
	ClutterActor* _tmp0_;
#line 23 "../src/view.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 23 "../src/view.vala"
	_tmp0_ = self->priv->_actor;
#line 23 "../src/view.vala"
	result = _tmp0_;
#line 23 "../src/view.vala"
	return result;
#line 502 "view.c"
}

ClutterCanvas*
rounded_rectangle_get_canvas (RoundedRectangle* self)
{
	ClutterCanvas* result;
	ClutterCanvas* _tmp0_;
#line 24 "../src/view.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 24 "../src/view.vala"
	_tmp0_ = self->priv->_canvas;
#line 24 "../src/view.vala"
	result = _tmp0_;
#line 24 "../src/view.vala"
	return result;
#line 518 "view.c"
}

static void
rounded_rectangle_set_x (RoundedRectangle* self,
                         gfloat value)
{
	ClutterActor* _tmp0_;
#line 26 "../src/view.vala"
	g_return_if_fail (self != NULL);
#line 26 "../src/view.vala"
	_tmp0_ = self->priv->_actor;
#line 26 "../src/view.vala"
	clutter_actor_set_x (_tmp0_, value);
#line 532 "view.c"
}

static void
rounded_rectangle_set_y (RoundedRectangle* self,
                         gfloat value)
{
	ClutterActor* _tmp0_;
#line 27 "../src/view.vala"
	g_return_if_fail (self != NULL);
#line 27 "../src/view.vala"
	_tmp0_ = self->priv->_actor;
#line 27 "../src/view.vala"
	clutter_actor_set_y (_tmp0_, value);
#line 546 "view.c"
}

static void
rounded_rectangle_set_width (RoundedRectangle* self,
                             gfloat value)
{
	ClutterActor* _tmp0_;
#line 28 "../src/view.vala"
	g_return_if_fail (self != NULL);
#line 28 "../src/view.vala"
	_tmp0_ = self->priv->_actor;
#line 28 "../src/view.vala"
	clutter_actor_set_width (_tmp0_, value);
#line 560 "view.c"
}

static void
rounded_rectangle_set_height (RoundedRectangle* self,
                              gfloat value)
{
	ClutterActor* _tmp0_;
#line 29 "../src/view.vala"
	g_return_if_fail (self != NULL);
#line 29 "../src/view.vala"
	_tmp0_ = self->priv->_actor;
#line 29 "../src/view.vala"
	clutter_actor_set_height (_tmp0_, value);
#line 574 "view.c"
}

guint8
rounded_rectangle_get_color (RoundedRectangle* self)
{
	guint8 result;
#line 107 "../src/view.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 107 "../src/view.vala"
	result = self->priv->_color_index;
#line 107 "../src/view.vala"
	return result;
#line 587 "view.c"
}

static void
rounded_rectangle_set_color (RoundedRectangle* self,
                             guint8 value)
{
	ClutterColor* color = NULL;
	GHashTable* _tmp0_;
	gconstpointer _tmp1_;
	ClutterColor* _tmp2_;
	ClutterColor* _tmp3_;
#line 108 "../src/view.vala"
	g_return_if_fail (self != NULL);
#line 109 "../src/view.vala"
	self->priv->_color_index = value;
#line 110 "../src/view.vala"
	_tmp0_ = rounded_rectangle_colors;
#line 110 "../src/view.vala"
	_tmp1_ = g_hash_table_lookup (_tmp0_, (gpointer) ((gintptr) value));
#line 110 "../src/view.vala"
	_tmp2_ = __vala_ClutterColor_copy0 ((ClutterColor*) _tmp1_);
#line 110 "../src/view.vala"
	color = _tmp2_;
#line 111 "../src/view.vala"
	_tmp3_ = color;
#line 111 "../src/view.vala"
	if (_tmp3_ == NULL) {
#line 615 "view.c"
		ClutterColor _tmp4_ = {0};
#line 112 "../src/view.vala"
		_rounded_rectangle_new_color (value, &_tmp4_);
#line 112 "../src/view.vala"
		self->priv->_color = _tmp4_;
#line 621 "view.c"
	} else {
		ClutterColor* _tmp5_;
#line 114 "../src/view.vala"
		_tmp5_ = color;
#line 114 "../src/view.vala"
		self->priv->_color = (ClutterColor) (*_tmp5_);
#line 628 "view.c"
	}
#line 108 "../src/view.vala"
	__vala_ClutterColor_free0 (color);
#line 632 "view.c"
}

static gboolean
__rounded_rectangle_draw_clutter_canvas_draw (ClutterCanvas* _sender,
                                              cairo_t* cr,
                                              gint width,
                                              gint height,
                                              gpointer self)
{
	gboolean result;
	result = _rounded_rectangle_draw ((RoundedRectangle*) self, cr, width, height);
#line 36 "../src/view.vala"
	return result;
#line 646 "view.c"
}

static GObject *
rounded_rectangle_constructor (GType type,
                               guint n_construct_properties,
                               GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	RoundedRectangle * self;
	ClutterActor* _tmp0_;
	ClutterCanvas* _tmp1_;
	ClutterActor* _tmp2_;
	ClutterCanvas* _tmp3_;
#line 31 "../src/view.vala"
	parent_class = G_OBJECT_CLASS (rounded_rectangle_parent_class);
#line 31 "../src/view.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 31 "../src/view.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ROUNDED_RECTANGLE, RoundedRectangle);
#line 33 "../src/view.vala"
	_tmp0_ = self->priv->_actor;
#line 33 "../src/view.vala"
	_tmp1_ = self->priv->_canvas;
#line 33 "../src/view.vala"
	clutter_actor_set_content (_tmp0_, (ClutterContent*) _tmp1_);
#line 34 "../src/view.vala"
	_tmp2_ = self->priv->_actor;
#line 34 "../src/view.vala"
	clutter_actor_set_pivot_point (_tmp2_, 0.5f, 0.5f);
#line 36 "../src/view.vala"
	_tmp3_ = self->priv->_canvas;
#line 36 "../src/view.vala"
	g_signal_connect_object (_tmp3_, "draw", (GCallback) __rounded_rectangle_draw_clutter_canvas_draw, self, 0);
#line 37 "../src/view.vala"
	rounded_rectangle_idle_resize (self);
#line 31 "../src/view.vala"
	return obj;
#line 685 "view.c"
}

static void
rounded_rectangle_class_init (RoundedRectangleClass * klass,
                              gpointer klass_data)
{
	GHashFunc _tmp0_;
	GEqualFunc _tmp1_;
	GHashTable* _tmp2_;
	GHashTable* _tmp3_;
	ClutterColor _tmp4_ = {0};
	ClutterColor* _tmp5_;
	GHashTable* _tmp6_;
	ClutterColor _tmp7_ = {0};
	ClutterColor* _tmp8_;
	GHashTable* _tmp9_;
	ClutterColor _tmp10_ = {0};
	ClutterColor* _tmp11_;
	GHashTable* _tmp12_;
	ClutterColor _tmp13_ = {0};
	ClutterColor* _tmp14_;
	GHashTable* _tmp15_;
	ClutterColor _tmp16_ = {0};
	ClutterColor* _tmp17_;
	GHashTable* _tmp18_;
	ClutterColor _tmp19_ = {0};
	ClutterColor* _tmp20_;
	GHashTable* _tmp21_;
	ClutterColor _tmp22_ = {0};
	ClutterColor* _tmp23_;
	GHashTable* _tmp24_;
	ClutterColor _tmp25_ = {0};
	ClutterColor* _tmp26_;
	GHashTable* _tmp27_;
	ClutterColor _tmp28_ = {0};
	ClutterColor* _tmp29_;
	GHashTable* _tmp30_;
	ClutterColor _tmp31_ = {0};
	ClutterColor* _tmp32_;
	GHashTable* _tmp33_;
	ClutterColor _tmp34_ = {0};
	ClutterColor* _tmp35_;
	GHashTable* _tmp36_;
	ClutterColor _tmp37_ = {0};
	ClutterColor* _tmp38_;
#line 21 "../src/view.vala"
	rounded_rectangle_parent_class = g_type_class_peek_parent (klass);
#line 21 "../src/view.vala"
	g_type_class_adjust_private_offset (klass, &RoundedRectangle_private_offset);
#line 21 "../src/view.vala"
	((RoundedRectangleClass *) klass)->_draw = (gboolean (*) (RoundedRectangle*, cairo_t*, gint, gint)) rounded_rectangle_real__draw;
#line 21 "../src/view.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_rounded_rectangle_get_property;
#line 21 "../src/view.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_rounded_rectangle_set_property;
#line 21 "../src/view.vala"
	G_OBJECT_CLASS (klass)->constructor = rounded_rectangle_constructor;
#line 21 "../src/view.vala"
	G_OBJECT_CLASS (klass)->finalize = rounded_rectangle_finalize;
#line 21 "../src/view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ROUNDED_RECTANGLE_ACTOR_PROPERTY, rounded_rectangle_properties[ROUNDED_RECTANGLE_ACTOR_PROPERTY] = g_param_spec_object ("actor", "actor", "actor", clutter_actor_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 21 "../src/view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ROUNDED_RECTANGLE_CANVAS_PROPERTY, rounded_rectangle_properties[ROUNDED_RECTANGLE_CANVAS_PROPERTY] = g_param_spec_object ("canvas", "canvas", "canvas", clutter_canvas_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 21 "../src/view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ROUNDED_RECTANGLE_X_PROPERTY, rounded_rectangle_properties[ROUNDED_RECTANGLE_X_PROPERTY] = g_param_spec_float ("x", "x", "x", -G_MAXFLOAT, G_MAXFLOAT, 0.0F, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY | G_PARAM_EXPLICIT_NOTIFY));
#line 21 "../src/view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ROUNDED_RECTANGLE_Y_PROPERTY, rounded_rectangle_properties[ROUNDED_RECTANGLE_Y_PROPERTY] = g_param_spec_float ("y", "y", "y", -G_MAXFLOAT, G_MAXFLOAT, 0.0F, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY | G_PARAM_EXPLICIT_NOTIFY));
#line 21 "../src/view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ROUNDED_RECTANGLE_WIDTH_PROPERTY, rounded_rectangle_properties[ROUNDED_RECTANGLE_WIDTH_PROPERTY] = g_param_spec_float ("width", "width", "width", -G_MAXFLOAT, G_MAXFLOAT, 0.0F, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY | G_PARAM_EXPLICIT_NOTIFY));
#line 21 "../src/view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ROUNDED_RECTANGLE_HEIGHT_PROPERTY, rounded_rectangle_properties[ROUNDED_RECTANGLE_HEIGHT_PROPERTY] = g_param_spec_float ("height", "height", "height", -G_MAXFLOAT, G_MAXFLOAT, 0.0F, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY | G_PARAM_EXPLICIT_NOTIFY));
#line 21 "../src/view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ROUNDED_RECTANGLE_COLOR_PROPERTY, rounded_rectangle_properties[ROUNDED_RECTANGLE_COLOR_PROPERTY] = g_param_spec_uchar ("color", "color", "color", 0, G_MAXUINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY | G_PARAM_EXPLICIT_NOTIFY));
#line 86 "../src/view.vala"
	_tmp0_ = g_direct_hash;
#line 86 "../src/view.vala"
	_tmp1_ = g_direct_equal;
#line 86 "../src/view.vala"
	_tmp2_ = g_hash_table_new_full (_tmp0_, _tmp1_, NULL, __vala_ClutterColor_free0_);
#line 86 "../src/view.vala"
	rounded_rectangle_colors = _tmp2_;
#line 90 "../src/view.vala"
	_tmp3_ = rounded_rectangle_colors;
#line 90 "../src/view.vala"
	clutter_color_from_string (&_tmp4_, "#ffffff");
#line 90 "../src/view.vala"
	_tmp5_ = __vala_ClutterColor_copy0 (&_tmp4_);
#line 90 "../src/view.vala"
	g_hash_table_insert (_tmp3_, (gpointer) ((gintptr) 0), _tmp5_);
#line 91 "../src/view.vala"
	_tmp6_ = rounded_rectangle_colors;
#line 91 "../src/view.vala"
	clutter_color_from_string (&_tmp7_, "#fce94f");
#line 91 "../src/view.vala"
	_tmp8_ = __vala_ClutterColor_copy0 (&_tmp7_);
#line 91 "../src/view.vala"
	g_hash_table_insert (_tmp6_, (gpointer) ((gintptr) 1), _tmp8_);
#line 92 "../src/view.vala"
	_tmp9_ = rounded_rectangle_colors;
#line 92 "../src/view.vala"
	clutter_color_from_string (&_tmp10_, "#8ae234");
#line 92 "../src/view.vala"
	_tmp11_ = __vala_ClutterColor_copy0 (&_tmp10_);
#line 92 "../src/view.vala"
	g_hash_table_insert (_tmp9_, (gpointer) ((gintptr) 2), _tmp11_);
#line 93 "../src/view.vala"
	_tmp12_ = rounded_rectangle_colors;
#line 93 "../src/view.vala"
	clutter_color_from_string (&_tmp13_, "#fcaf3e");
#line 93 "../src/view.vala"
	_tmp14_ = __vala_ClutterColor_copy0 (&_tmp13_);
#line 93 "../src/view.vala"
	g_hash_table_insert (_tmp12_, (gpointer) ((gintptr) 3), _tmp14_);
#line 94 "../src/view.vala"
	_tmp15_ = rounded_rectangle_colors;
#line 94 "../src/view.vala"
	clutter_color_from_string (&_tmp16_, "#729fcf");
#line 94 "../src/view.vala"
	_tmp17_ = __vala_ClutterColor_copy0 (&_tmp16_);
#line 94 "../src/view.vala"
	g_hash_table_insert (_tmp15_, (gpointer) ((gintptr) 4), _tmp17_);
#line 95 "../src/view.vala"
	_tmp18_ = rounded_rectangle_colors;
#line 95 "../src/view.vala"
	clutter_color_from_string (&_tmp19_, "#ad7fa8");
#line 95 "../src/view.vala"
	_tmp20_ = __vala_ClutterColor_copy0 (&_tmp19_);
#line 95 "../src/view.vala"
	g_hash_table_insert (_tmp18_, (gpointer) ((gintptr) 5), _tmp20_);
#line 96 "../src/view.vala"
	_tmp21_ = rounded_rectangle_colors;
#line 96 "../src/view.vala"
	clutter_color_from_string (&_tmp22_, "#c17d11");
#line 96 "../src/view.vala"
	_tmp23_ = __vala_ClutterColor_copy0 (&_tmp22_);
#line 96 "../src/view.vala"
	g_hash_table_insert (_tmp21_, (gpointer) ((gintptr) 6), _tmp23_);
#line 97 "../src/view.vala"
	_tmp24_ = rounded_rectangle_colors;
#line 97 "../src/view.vala"
	clutter_color_from_string (&_tmp25_, "#ef2929");
#line 97 "../src/view.vala"
	_tmp26_ = __vala_ClutterColor_copy0 (&_tmp25_);
#line 97 "../src/view.vala"
	g_hash_table_insert (_tmp24_, (gpointer) ((gintptr) 7), _tmp26_);
#line 98 "../src/view.vala"
	_tmp27_ = rounded_rectangle_colors;
#line 98 "../src/view.vala"
	clutter_color_from_string (&_tmp28_, "#c4a000");
#line 98 "../src/view.vala"
	_tmp29_ = __vala_ClutterColor_copy0 (&_tmp28_);
#line 98 "../src/view.vala"
	g_hash_table_insert (_tmp27_, (gpointer) ((gintptr) 8), _tmp29_);
#line 99 "../src/view.vala"
	_tmp30_ = rounded_rectangle_colors;
#line 99 "../src/view.vala"
	clutter_color_from_string (&_tmp31_, "#4e9a06");
#line 99 "../src/view.vala"
	_tmp32_ = __vala_ClutterColor_copy0 (&_tmp31_);
#line 99 "../src/view.vala"
	g_hash_table_insert (_tmp30_, (gpointer) ((gintptr) 9), _tmp32_);
#line 100 "../src/view.vala"
	_tmp33_ = rounded_rectangle_colors;
#line 100 "../src/view.vala"
	clutter_color_from_string (&_tmp34_, "#ce5c00");
#line 100 "../src/view.vala"
	_tmp35_ = __vala_ClutterColor_copy0 (&_tmp34_);
#line 100 "../src/view.vala"
	g_hash_table_insert (_tmp33_, (gpointer) ((gintptr) 10), _tmp35_);
#line 101 "../src/view.vala"
	_tmp36_ = rounded_rectangle_colors;
#line 101 "../src/view.vala"
	clutter_color_from_string (&_tmp37_, "#204a87");
#line 101 "../src/view.vala"
	_tmp38_ = __vala_ClutterColor_copy0 (&_tmp37_);
#line 101 "../src/view.vala"
	g_hash_table_insert (_tmp36_, (gpointer) ((gintptr) 11), _tmp38_);
#line 863 "view.c"
}

static void
rounded_rectangle_instance_init (RoundedRectangle * self,
                                 gpointer klass)
{
	ClutterActor* _tmp0_;
	ClutterCanvas* _tmp1_;
#line 21 "../src/view.vala"
	self->priv = rounded_rectangle_get_instance_private (self);
#line 23 "../src/view.vala"
	_tmp0_ = clutter_actor_new ();
#line 23 "../src/view.vala"
	g_object_ref_sink (_tmp0_);
#line 23 "../src/view.vala"
	self->priv->_actor = _tmp0_;
#line 24 "../src/view.vala"
	_tmp1_ = (ClutterCanvas*) clutter_canvas_new ();
#line 24 "../src/view.vala"
	self->priv->_canvas = _tmp1_;
#line 884 "view.c"
}

static void
rounded_rectangle_finalize (GObject * obj)
{
	RoundedRectangle * self;
#line 21 "../src/view.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ROUNDED_RECTANGLE, RoundedRectangle);
#line 23 "../src/view.vala"
	_g_object_unref0 (self->priv->_actor);
#line 24 "../src/view.vala"
	_g_object_unref0 (self->priv->_canvas);
#line 21 "../src/view.vala"
	G_OBJECT_CLASS (rounded_rectangle_parent_class)->finalize (obj);
#line 899 "view.c"
}

static GType
rounded_rectangle_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (RoundedRectangleClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) rounded_rectangle_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RoundedRectangle), 0, (GInstanceInitFunc) rounded_rectangle_instance_init, NULL };
	GType rounded_rectangle_type_id;
	rounded_rectangle_type_id = g_type_register_static (G_TYPE_OBJECT, "RoundedRectangle", &g_define_type_info, 0);
	RoundedRectangle_private_offset = g_type_add_instance_private (rounded_rectangle_type_id, sizeof (RoundedRectanglePrivate));
	return rounded_rectangle_type_id;
}

GType
rounded_rectangle_get_type (void)
{
	static volatile gsize rounded_rectangle_type_id__once = 0;
	if (g_once_init_enter (&rounded_rectangle_type_id__once)) {
		GType rounded_rectangle_type_id;
		rounded_rectangle_type_id = rounded_rectangle_get_type_once ();
		g_once_init_leave (&rounded_rectangle_type_id__once, rounded_rectangle_type_id);
	}
	return rounded_rectangle_type_id__once;
}

static void
_vala_rounded_rectangle_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec)
{
	RoundedRectangle * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_ROUNDED_RECTANGLE, RoundedRectangle);
#line 21 "../src/view.vala"
	switch (property_id) {
#line 21 "../src/view.vala"
		case ROUNDED_RECTANGLE_ACTOR_PROPERTY:
#line 21 "../src/view.vala"
		g_value_set_object (value, rounded_rectangle_get_actor (self));
#line 21 "../src/view.vala"
		break;
#line 21 "../src/view.vala"
		case ROUNDED_RECTANGLE_CANVAS_PROPERTY:
#line 21 "../src/view.vala"
		g_value_set_object (value, rounded_rectangle_get_canvas (self));
#line 21 "../src/view.vala"
		break;
#line 21 "../src/view.vala"
		case ROUNDED_RECTANGLE_COLOR_PROPERTY:
#line 21 "../src/view.vala"
		g_value_set_uchar (value, rounded_rectangle_get_color (self));
#line 21 "../src/view.vala"
		break;
#line 952 "view.c"
		default:
#line 21 "../src/view.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../src/view.vala"
		break;
#line 958 "view.c"
	}
}

static void
_vala_rounded_rectangle_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec)
{
	RoundedRectangle * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_ROUNDED_RECTANGLE, RoundedRectangle);
#line 21 "../src/view.vala"
	switch (property_id) {
#line 21 "../src/view.vala"
		case ROUNDED_RECTANGLE_X_PROPERTY:
#line 21 "../src/view.vala"
		rounded_rectangle_set_x (self, g_value_get_float (value));
#line 21 "../src/view.vala"
		break;
#line 21 "../src/view.vala"
		case ROUNDED_RECTANGLE_Y_PROPERTY:
#line 21 "../src/view.vala"
		rounded_rectangle_set_y (self, g_value_get_float (value));
#line 21 "../src/view.vala"
		break;
#line 21 "../src/view.vala"
		case ROUNDED_RECTANGLE_WIDTH_PROPERTY:
#line 21 "../src/view.vala"
		rounded_rectangle_set_width (self, g_value_get_float (value));
#line 21 "../src/view.vala"
		break;
#line 21 "../src/view.vala"
		case ROUNDED_RECTANGLE_HEIGHT_PROPERTY:
#line 21 "../src/view.vala"
		rounded_rectangle_set_height (self, g_value_get_float (value));
#line 21 "../src/view.vala"
		break;
#line 21 "../src/view.vala"
		case ROUNDED_RECTANGLE_COLOR_PROPERTY:
#line 21 "../src/view.vala"
		rounded_rectangle_set_color (self, g_value_get_uchar (value));
#line 21 "../src/view.vala"
		break;
#line 1002 "view.c"
		default:
#line 21 "../src/view.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../src/view.vala"
		break;
#line 1008 "view.c"
	}
}

TileView*
tile_view_construct (GType object_type,
                     gfloat x,
                     gfloat y,
                     gfloat width,
                     gfloat height,
                     guint8 val)
{
	TileView * self = NULL;
#line 140 "../src/view.vala"
	self = (TileView*) g_object_new (object_type, "x", x, "y", y, "width", width, "height", height, "color", val, NULL);
#line 138 "../src/view.vala"
	return self;
#line 1025 "view.c"
}

TileView*
tile_view_new (gfloat x,
               gfloat y,
               gfloat width,
               gfloat height,
               guint8 val)
{
#line 138 "../src/view.vala"
	return tile_view_construct (TYPE_TILE_VIEW, x, y, width, height, val);
#line 1037 "view.c"
}

static gchar*
double_to_string (gdouble self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint _tmp1__length1;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* result;
#line 997 "glib-2.0.vapi"
	_tmp0_ = g_new0 (gchar, G_ASCII_DTOSTR_BUF_SIZE);
#line 997 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 997 "glib-2.0.vapi"
	_tmp1__length1 = G_ASCII_DTOSTR_BUF_SIZE;
#line 997 "glib-2.0.vapi"
	_tmp2_ = g_ascii_dtostr (_tmp1_, (gint) G_ASCII_DTOSTR_BUF_SIZE, self);
#line 997 "glib-2.0.vapi"
	_tmp3_ = g_strdup (_tmp2_);
#line 997 "glib-2.0.vapi"
	_tmp4_ = _tmp3_;
#line 997 "glib-2.0.vapi"
	_tmp1_ = (g_free (_tmp1_), NULL);
#line 997 "glib-2.0.vapi"
	result = _tmp4_;
#line 997 "glib-2.0.vapi"
	return result;
#line 1068 "view.c"
}

static void
_vala_PangoFontDescription_free (PangoFontDescription* self)
{
#line 161 "../src/view.vala"
	g_boxed_free (pango_font_description_get_type (), self);
#line 1076 "view.c"
}

static gboolean
tile_view_real__draw (RoundedRectangle* base,
                      cairo_t* ctx,
                      gint width,
                      gint height)
{
	TileView * self;
	PangoLayout* layout = NULL;
	PangoLayout* _tmp0_;
	PangoFontDescription* font_desc = NULL;
	gchar* _tmp1_;
	gchar* _tmp2_;
	PangoFontDescription* _tmp3_;
	PangoFontDescription* _tmp4_;
	guint8 _tmp5_;
	guint8 _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	PangoRectangle logical_rect = {0};
	PangoRectangle _tmp9_ = {0};
	PangoRectangle _tmp10_;
	PangoRectangle _tmp11_;
	gboolean result;
#line 143 "../src/view.vala"
	self = (TileView*) base;
#line 143 "../src/view.vala"
	g_return_val_if_fail (ctx != NULL, FALSE);
#line 145 "../src/view.vala"
	ROUNDED_RECTANGLE_CLASS (tile_view_parent_class)->_draw (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_ROUNDED_RECTANGLE, RoundedRectangle), ctx, width, height);
#line 147 "../src/view.vala"
	cairo_set_source_rgb (ctx, (gdouble) 255, (gdouble) 255, (gdouble) 255);
#line 149 "../src/view.vala"
	_tmp0_ = pango_cairo_create_layout (ctx);
#line 149 "../src/view.vala"
	layout = _tmp0_;
#line 150 "../src/view.vala"
	_tmp1_ = g_strdup_printf ("Sans Bold %dpx", height / 4);
#line 150 "../src/view.vala"
	_tmp2_ = _tmp1_;
#line 150 "../src/view.vala"
	_tmp3_ = pango_font_description_from_string (_tmp2_);
#line 150 "../src/view.vala"
	_tmp4_ = _tmp3_;
#line 150 "../src/view.vala"
	_g_free0 (_tmp2_);
#line 150 "../src/view.vala"
	font_desc = _tmp4_;
#line 151 "../src/view.vala"
	pango_layout_set_font_description (layout, font_desc);
#line 153 "../src/view.vala"
	_tmp5_ = rounded_rectangle_get_color ((RoundedRectangle*) self);
#line 153 "../src/view.vala"
	_tmp6_ = _tmp5_;
#line 153 "../src/view.vala"
	_tmp7_ = double_to_string (pow ((gdouble) 2, (gdouble) _tmp6_));
#line 153 "../src/view.vala"
	_tmp8_ = _tmp7_;
#line 153 "../src/view.vala"
	pango_layout_set_text (layout, _tmp8_, -1);
#line 153 "../src/view.vala"
	_g_free0 (_tmp8_);
#line 156 "../src/view.vala"
	pango_layout_get_extents (layout, NULL, &_tmp9_);
#line 156 "../src/view.vala"
	logical_rect = _tmp9_;
#line 157 "../src/view.vala"
	_tmp10_ = logical_rect;
#line 157 "../src/view.vala"
	_tmp11_ = logical_rect;
#line 157 "../src/view.vala"
	cairo_move_to (ctx, (gdouble) ((width / 2) - ((_tmp10_.width / 2) / PANGO_SCALE)), (gdouble) ((height / 2) - ((_tmp11_.height / 2) / PANGO_SCALE)));
#line 159 "../src/view.vala"
	pango_cairo_show_layout (ctx, layout);
#line 161 "../src/view.vala"
	result = FALSE;
#line 161 "../src/view.vala"
	__vala_PangoFontDescription_free0 (font_desc);
#line 161 "../src/view.vala"
	_g_object_unref0 (layout);
#line 161 "../src/view.vala"
	return result;
#line 1160 "view.c"
}

static void
tile_view_class_init (TileViewClass * klass,
                      gpointer klass_data)
{
#line 136 "../src/view.vala"
	tile_view_parent_class = g_type_class_peek_parent (klass);
#line 136 "../src/view.vala"
	((RoundedRectangleClass *) klass)->_draw = (gboolean (*) (RoundedRectangle*, cairo_t*, gint, gint)) tile_view_real__draw;
#line 1171 "view.c"
}

static void
tile_view_instance_init (TileView * self,
                         gpointer klass)
{
}

static GType
tile_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TileViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tile_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TileView), 0, (GInstanceInitFunc) tile_view_instance_init, NULL };
	GType tile_view_type_id;
	tile_view_type_id = g_type_register_static (TYPE_ROUNDED_RECTANGLE, "TileView", &g_define_type_info, 0);
	return tile_view_type_id;
}

GType
tile_view_get_type (void)
{
	static volatile gsize tile_view_type_id__once = 0;
	if (g_once_init_enter (&tile_view_type_id__once)) {
		GType tile_view_type_id;
		tile_view_type_id = tile_view_get_type_once ();
		g_once_init_leave (&tile_view_type_id__once, tile_view_type_id);
	}
	return tile_view_type_id__once;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

